<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AirlinePath.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">airline-graph</a> &gt; <a href="index.source.html" class="el_package">com.boxever.challenge.airline</a> &gt; <span class="el_source">AirlinePath.java</span></div><h1>AirlinePath.java</h1><pre class="source lang-java linenums">package com.boxever.challenge.airline;

import lombok.Getter;
import org.jgrapht.GraphPath;
import org.jgrapht.graph.DefaultWeightedEdge;

import java.util.List;

@Getter
public class AirlinePath {

<span class="nc" id="L12">    private GraphPath&lt;String, DefaultWeightedEdge&gt; path;</span>

<span class="fc" id="L14">    public AirlinePath(GraphPath&lt;String, DefaultWeightedEdge&gt; path) {</span>
<span class="fc" id="L15">        this.path = path;</span>
<span class="fc" id="L16">    }</span>

    public boolean exists() {
<span class="pc bpc" id="L19" title="1 of 2 branches missed.">        return null != path;</span>
    }

    @Override
    public String toString() {
<span class="fc" id="L24">        StringBuilder acc = new StringBuilder();</span>
<span class="fc" id="L25">        List&lt;String&gt; airports = path.getVertexList();</span>
<span class="fc bfc" id="L26" title="All 2 branches covered.">        for(int i=0; i&lt;airports.size()-1; i++) {</span>
<span class="fc" id="L27">            appendStep(acc, airports.get(i), airports.get(i+1));</span>
        }
<span class="fc" id="L29">        acc.append(&quot;Time: &quot; + (int)path.getWeight());</span>
<span class="fc" id="L30">        return acc.toString();</span>
    }

    private void appendStep(StringBuilder path, String source, String dest) {
<span class="fc" id="L34">        path</span>
<span class="fc" id="L35">            .append(source)</span>
<span class="fc" id="L36">            .append(&quot; -- &quot;)</span>
<span class="fc" id="L37">            .append(dest)</span>
<span class="fc" id="L38">            .append(&quot;(&quot;)</span>
<span class="fc" id="L39">            .append(getDistance(source, dest))</span>
<span class="fc" id="L40">            .append(&quot;)\n&quot;);</span>
<span class="fc" id="L41">    }</span>

    private Integer getDistance(String source, String dest) {
<span class="fc" id="L44">        DefaultWeightedEdge e = this.path.getGraph().getEdge(source, dest);</span>
<span class="fc" id="L45">        return (int)this.path.getGraph().getEdgeWeight(e);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.6.202009150832</span></div></body></html>